Botan 2.13.0 Crypto and TLS for C++11

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | List of all members
Botan::Intel_Rdrand Class Referencefinal

`#include <rdrand.h>`

Inheritance diagram for Botan::Intel_Rdrand:

## Public Member Functions
std::string | name () const override
size_t | poll (RandomNumberGenerator &rng) override

## Static Public Member Functions
static std::unique_ptr< Entropy_Source > | create (const std::string &type)

## Detailed Description

Entropy source using the rdrand instruction first introduced on Intel's Ivy Bridge architecture.

Definition at line 19 of file rdrand.h.

## Member Function Documentation

std::unique_ptr< Entropy_Source > Botan::Entropy_Source::create | ( | const std::string & | type | ) |
| static inherited

Return a new entropy source of a particular type, or null Each entropy source may require substantial resources (eg, a file handle or socket instance), so try to share them among multiple RNGs, or just use the preconfigured global list accessed by Entropy_Sources::global_sources()

Definition at line 67 of file entropy_srcs.cpp.

References BOTAN_UNUSED, and Botan::OS::running_in_privileged_state().

Referenced by Botan::Entropy_Sources::Entropy_Sources().

68 {
69 #if defined(BOTAN_HAS_SYSTEM_RNG)
70 if(name == "system_rng" || name == "win32_cryptoapi")
71 {
72 return std::unique_ptr<Entropy_Source>(new System_RNG_EntropySource);
73 }
74 #endif
75
76 #if defined(BOTAN_HAS_ENTROPY_SRC_RDRAND)
77 if(name == "rdrand")
78 {
79 return std::unique_ptr<Entropy_Source>(new Intel_Rdrand);
80 }
81 #endif
82
83 #if defined(BOTAN_HAS_ENTROPY_SRC_RDSEED)
84 if(name == "rdseed")
85 {
86 return std::unique_ptr<Entropy_Source>(new Intel_Rdseed);
87 }
88 #endif
89
90 #if defined(BOTAN_HAS_ENTROPY_SRC_DARN)
91 if(name == "p9_darn")
92 {
93 return std::unique_ptr<Entropy_Source>(new POWER9_DARN);
94 }
95 #endif
96
97 #if defined(BOTAN_HAS_ENTROPY_SRC_GETENTROPY)
98 if(name == "getentropy")
99 {
100 return std::unique_ptr<Entropy_Source>(new Getentropy);
101 }
102 #endif
103
104 #if defined(BOTAN_HAS_ENTROPY_SRC_DEV_RANDOM)
105 if(name == "dev_random")
106 {
107 return std::unique_ptr<Entropy_Source>(new Device_EntropySource(BOTAN_SYSTEM_RNG_POLL_DEVICES));
108 }
109 #endif
110
111 #if defined(BOTAN_HAS_ENTROPY_SRC_PROC_WALKER)
112 if(name == "proc_walk" && OS::running_in_privileged_state() == false)
113 {
114 const std::string root_dir = BOTAN_ENTROPY_PROC_FS_PATH;
115 if(!root_dir.empty())
116 return std::unique_ptr<Entropy_Source>(new ProcWalking_EntropySource(root_dir));
117 }
118 #endif
119
120 #if defined(BOTAN_HAS_ENTROPY_SRC_WIN32)
121 if(name == "system_stats")
122 {
123 return std::unique_ptr<Entropy_Source>(new Win32_EntropySource);
124 }
125 #endif
126
127 BOTAN_UNUSED(name);
128 return std::unique_ptr<Entropy_Source>();
129 }
Botan::Entropy_Source::name
virtual std::string name() const =0
Botan::OS::running_in_privileged_state
bool running_in_privileged_state()
Definition: os_utils.cpp:143
BOTAN_UNUSED
#define BOTAN_UNUSED(...)
Definition: assert.h:142

std::string Botan::Intel_Rdrand::name | ( |  | ) | const
| inline override virtual

Returns
  name identifying this entropy source

Implements Botan::Entropy_Source.

Definition at line 22 of file rdrand.h.

22 { return "rdrand"; }

size_t Botan::Intel_Rdrand::poll | ( | RandomNumberGenerator & | rng | ) |
| override virtual

Perform an entropy gathering poll

Parameters

  rng | will be provided with entropy via calls to add_entropy

Returns
  conservative estimate of actual entropy added to rng during poll

Implements Botan::Entropy_Source.

Definition at line 14 of file rdrand.cpp.

References Botan::RandomNumberGenerator::add_entropy(), Botan::RDRAND_RNG::available(), and Botan::RDRAND_RNG::randomize().

15 {
16 /*
17 * Intel's documentation for RDRAND at
18 * https://software.intel.com/en-us/articles/intel-digital-random-number-generator-drng-software-implementation-guide
19 * claims that software can guarantee a reseed event by polling enough data:
20 * "There is an upper bound of 511 samples per seed in the implementation
21 * where samples are 128 bits in size and can provide two 64-bit random
22 * numbers each."
23 *
24 * By requesting 8192 bytes we are asking for 512 samples and thus are assured
25 * that at some point in producing the output, at least one reseed of the
26 * internal state will occur.
27 *
28 * The alternative approach is to "Iteratively execute 32 RDRAND invocations
29 * with a 10 us wait period per iteration." however in practice this proves to
30 * be about 20x slower, despite producing much less seed material.
31 */
32 const size_t RDRAND_POLL_BYTES = 8*1024;
33
34 if(RDRAND_RNG::available())
35 {
36 RDRAND_RNG rdrand_rng;
37 secure_vector<uint8_t> buf(RDRAND_POLL_BYTES);
38 rdrand_rng.randomize(&buf[0], buf.size());
39 rng.add_entropy(buf.data(), buf.size());
40 }
41
42 // RDRAND is used but not trusted
43 return 0;
44 }
Botan::RDRAND_RNG::available
static bool available()
Definition: rdrand_rng.cpp:85

The documentation for this class was generated from the following files:

- src/lib/entropy/rdrand/rdrand.h
- src/lib/entropy/rdrand/rdrand.cpp